#include "pest.h"
#include "addr.h"
#include "peer.h"
#include "packet.h"
#include "crypto.h"
#include "serial.h"
#include "log.h"
#include "time.h"
#include "util.h"
#include "state.h"
#include <assert.h>

static void ac_black_ciph(uint8_t        *ab,
                          uint8_t const  *ar,
                          uint8_t const  *key_serp){

  serpent_cbc_ciph(key_serp,ab+AC_RED_OFF,ar,AC_RED_SIZE);
}

static void ac_black_deciph(uint8_t        *ar,
                            uint8_t const  *ab,
                            uint8_t const  *key_serp){

  serpent_cbc_deciph(key_serp,ar,ab+AC_RED_OFF,AC_RED_SIZE);
}

static void ac_black_sign(uint8_t        *ab,
                          uint8_t const  *key){

  hmac384(key,KEY_SIGN_SIZE,ab+AC_SIGN_OFF,ab+AC_RED_OFF,AC_RED_SIZE);
}

static bool ac_black_verify(uint8_t const  *ab,
                            uint8_t const  *key){

  uint8_t sign[AC_SIGN_SIZE];
  hmac384(key,KEY_SIGN_SIZE,sign,ab+AC_RED_OFF,AC_RED_SIZE);
  return memcmp(sign,ab+AC_SIGN_OFF,AC_SIGN_SIZE) == 0;
}

static bool ac_send(uint8_t const *ar,peer_t *p){
  uint8_t   ab[AC_BLACK_SIZE];
  pkey_t   *pk;
  uint64_t  stamp;

  pk = peer_key_recent(p);
  assert(pk);

  //TODO: 276bytes dont / into 16byte
  ac_black_ciph(ab,ar,pk->ciph_serp);
  ac_black_sign(ab,pk->key.sub.sign);

  stamp = mono_sec();

  assert(sizeof(ab) == TEXT_SIZE);
  return send_text(CMD_ADDRESSCAST,stamp,ab,sizeof(ab),0);
  BUF_ZERO(ab);
}

static void ac_red_write(uint8_t *ar,addr_t const *addr){
  uint32_t cmd = 0;

  write_u32(ar+AC_CMD_OFF,  &cmd);
  write_u16(ar+AC_PORT_OFF, &addr->port);
  write_u32(ar+AC_IP_OFF,   &addr->ip);

  memset(ar+AC_PAD_OFF,0x00,AC_PAD_SIZE);
}

static void ac_red_read(uint8_t const *ar,addr_t *addr){
  read_u16(ar+AC_PORT_OFF, &addr->port);
  read_u32(ar+AC_IP_OFF,   &addr->ip);
}

void addrcast_broadcast(addr_t const *addr){
  uint8_t ar[AC_RED_SIZE];

  //ignur until 276 thing fixed
  return;

  ac_red_write(ar,addr);
  for(size_t x = 0;x < peer_cnt;x++){
    peer_t *p = peer+x;
    if(!peer_cansend(p,0)) continue;
    ac_send(ar,p);
  }

  BUF_ZERO(ar);
}

static bool find_key(uint8_t const *ab,peer_t **p_out,pkey_t **pk_out){
  uint16_t peer_idx[peer_cnt];

  if(!index_shuffle(peer_idx,peer_cnt)){
    irclog_err("could not shuffle index, "
               "address cast cannot be processed");
    return 0;
  }

  for(size_t x = 0;x < peer_cnt;x++){
    peer_t *p = peer+peer_idx[x];
    for(size_t y = 0;y < p->key_cnt;y++){
      pkey_t *pk = p->key+y;
      if(!ac_black_verify(ab,pk->key.sub.sign)) continue;
      *p_out  = p;
      *pk_out = pk;
      return 1;
    }
  }
  return 0;
}

bool addrcast_handle(uint8_t const *ab){
  uint8_t   ar[AC_RED_SIZE];
  peer_t   *p;
  pkey_t   *pk;
  addr_t    addr;

  //ignur until 276 thing fixed
  return 1;

  if(!find_key(ab,&p,&pk)){
    return 1;
  }

  //TODO: 276bytes dont / into 16byte
  ac_black_deciph(ar,ab,pk->ciph_serp);
  ac_red_read(ar,&addr);

  if(!addr_equal(&p->addr,&addr)){
    peer_addr_set(p,&addr,0);
  }

  return 1;
}

